<?php

// +---------------------------------------------------------------------------+
// | Things to do Plugin 1.0 for  Geeklog Plugin 1.3.9                         |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | admin/index.php                                                           |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Euan McKay                  -    euan@heatherengineering.com              |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');

// Only let admin users access this page
if (!SEC_hasRights('thingstodo.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the thingstodo Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_THINGS00['access_denied']);
    $display .= $LANG_THINGS00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}


/*
* Function:        thingstodo_adminPage()
*
* Takes input:     none
*
* Returns:         HTML                       : a page of HTML to display
*/

function thingstodo_adminPage() {

    global $LANG_THINGS_CB, $_CONF, $_USER, $_TABLES, $LANG_THINGS02;

    $retval = '';
    $selected = DB_getItem($_TABLES['thingstodo_vars'],'val',"ref='cb_options'");
    $home = DB_getItem($_TABLES['thingstodo_vars'],'val',"ref='cb_home'");
    $options = '';
    foreach ($LANG_THINGS_CB as $k => $v) {
        $options .= '<option value="'.$k.'"';
        if ($k == $selected) {
            $options .= ' selected="selected"';
        }
        $options .= '>'.$v.'</option>';
    }
    $T = new Template($_CONF['path_layout'] . 'thingstodo');
    $T->set_file('admin', 'admin.thtml');
    $T->set_var('layout_url',$_CONF['layout_url']);
    $T->set_var('site_url',$_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('plugin','thingstodo');
    $T->set_var('header', $LANG_THINGS02['1']);
    $T->set_var('admin_home', $LANG_THINGS02['2']);
    $T->set_var('ttd_admin_home', $LANG_THINGS02['3']);
    $T->set_var('lang_centerblock', $LANG_THINGS02['4']);
    $T->set_var('lang_position', $LANG_THINGS02['5']);
    $T->set_var('lang_warning', $LANG_THINGS02['10']);
    $T->set_var('lang_save', $LANG_THINGS02['6']);
    $T->set_var('lang_cancel', $LANG_THINGS02['7']);
    $T->set_var('lang_homepage', $LANG_THINGS02['11']);
    $T->set_var('lang_yes', $LANG_THINGS02['12']);
    $T->set_var('lang_no', $LANG_THINGS02['13']);
    if ($home == '0') {
        $T->set_var('no', ' CHECKED');
        $T->set_var('yes', '');
    } else {
        $T->set_var('yes', ' CHECKED');
        $T->set_var('no', '');
    }
    $T->set_var('cb_options', $options);
    $T->parse('output','admin');
    $retval = $T->finish($T->get_var('output'));

    return $retval;
}


/*
* Function:        thingstodo_saveAdmin()
*
* Takes input:     $item (array, required)    : array of data to be saved
*
* Returns:         text                       : a message describing the result of the request
*/

function thingstodo_saveAdmin($item) {
    global $_TABLES, $_CONF, $_USER, $LANG_THINGS02;
    $retval = '';

    if (!SEC_hasRights('thingstodo.admin')) {
        COM_accessLog("User {$_USER['username']} tried illegally to edit thingstodo Admin.");
        $retval = "Illegal access!!!!!!!!";
    } else {

        $ref1 = 'cb_options';
        $val1 = COM_applyFilter($item['cb_options']);
        $sql1 = "UPDATE {$_TABLES['thingstodo_vars']} SET val='{$val1}' WHERE ref='{$ref1}'";
        $ref2 = 'cb_home';
        $val2 = COM_applyFilter($item['cb_home']);
        $sql2 = "UPDATE {$_TABLES['thingstodo_vars']} SET val='{$val2}' WHERE ref='{$ref2}'";

        DB_query($sql1);
        DB_query($sql2);
        if (DB_error()) {
            $retval = $LANG_THINGS02[9];
        } else {
            $retval = $LANG_THINGS02[8];
        }
    }
    return $retval;
}

/*
* Main 
*/

$mode = COM_applyFilter($HTTP_POST_VARS['mode']);
if (($mode == $LANG_THINGS02[6]) && ($mode<>'')) {      // save an item
    $msg = thingstodo_saveAdmin ($HTTP_POST_VARS);      // OK so save item
    $content = thingstodo_adminPage();                  // get items
} else {
    $content = thingstodo_adminPage();                             // standard admin page
}
$display = '';

$display  = COM_siteHeader();
if ($msg <> '') {
    $display .= COM_startBlock($LANG_THINGS02['1']);
    $display .= $msg;
    $display .= COM_endBlock();
}
$display .= $content;
$display .= COM_siteFooter(true);

echo $display;
?>
