<?php

// +---------------------------------------------------------------------------+
// | Things to do Plugin 1.0 for  Geeklog Plugin 1.3.9                         |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | admin/install.php                                                         |
// | Installation page.                                                        |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Euan McKay                  -    euan@heatherengineering.com              |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_CONF['path'] . 'plugins/thingstodo/config.php');
require_once($_CONF['path'] . 'plugins/thingstodo/functions.inc');

//
// Universal plugin install variables
//

$pi_name = 'thingstodo';                        // Plugin name  Must be 15 chars or less
$pi_version = '1.3';                            // Plugin Version
$gl_version = '1.3.9';                          // GL Version plugin for
$pi_url = 'http://heatherengineering.com/';     // Plugin Homepage

//
// $NEWTABLE contains table name(s) and sql to create it(them)
// Fill it in and you are ready to go.
// Note: you must put the table names in the uninstall routine in functions.inc 
// and in the $_TABLES array in config.php.
// Note: Be sure to replace thingstodo, table2 with the actual names of your tables.
// and the table definition with the definition of your table
//

$NEWTABLE = array();
$NEWTABLE['thingstodo'] = "CREATE TABLE " . $_TABLES['thingstodo'] . " (
  `id` int(10) unsigned NOT NULL auto_increment,
  `agent` mediumint(8) NOT NULL default '1',
  `title` varchar(255) default NULL,
  `description` text,
  `type` varchar(30) NOT NULL default 'normal',
  `tid` varchar(20) default NULL,
  `priority` smallint(5) NOT NULL default '3',
  `status` smallint(5) NOT NULL default '0',
  `start` varchar(14) default NULL,
  `end` varchar(14) default NULL,
  `created` varchar(14) default NULL,
  `modified` varchar(14) default NULL,
  `owner_id` mediumint(8) NOT NULL default '1',
  `group_id` mediumint(8) NOT NULL default '2',
  `perm_owner` tinyint(1) unsigned NOT NULL default '3',
  `perm_group` tinyint(1) unsigned NOT NULL default '3',
  `perm_members` tinyint(1) unsigned NOT NULL default '2',
  `perm_anon` tinyint(1) unsigned NOT NULL default '2',
  PRIMARY KEY  (`id`),
  KEY `thingstodo_id` (`id`),
  KEY `thingstodo_type` (`type`),
  KEY `thingstodo_sid` (`start`),
  KEY `thingstodo_date` (`end`),
  KEY `thingstodo_agent` (`agent`),
  KEY `thingstodo_status` (`status`)
  ) TYPE=MyISAM AUTO_INCREMENT=1 ;";

$NEWTABLE['thingstodo_vars'] = "CREATE TABLE " . $_TABLES['thingstodo_vars'] . " (
  `ref` varchar(255) default NULL,
  `val` varchar(255) default NULL
) TYPE=MyISAM;";


//
// Default data
// Insert table name and sql to insert default data for your plugin.
//
$DEFVALUES = array();
$DEFVALUES[1] = "INSERT INTO `gl_thingstodo_vars` (`ref`, `val`) VALUES ('cb_options', '1');";
$DEFVALUES[2] = "INSERT INTO `gl_thingstodo_vars` (`ref`, `val`) VALUES ('cb_home', '0');";

//
// Security Feature to add
// Fill in your security features here
// Note you must add these features to the uninstall routine in function.inc so that they will
// be removed when the uninstall routine runs.
// You do not have to use these particular features.  You can edit/add/delete them
// to fit your plugins security model
//

$NEWFEATURE = array( 0 => array( 'feature'     => "thingstodo.admin",
                                 'group'       => "Things to do Admin",
                                 'description' => "Users in this group can administer the Things to do plugin"),
                     1 => array( 'feature'     => "thingstodo.user",
                                 'group'       => "Things to do User",
                                 'description' => "Users in this group can use the Things to do plugin"));


// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the thingstodo install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_THINGS00['access_denied']);
    $display .= $LANG_THINGS00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Puts the datastructures for this plugin into the Geeklog database
*
* Note: Corresponding uninstall routine is in functions.inc
* 
* @return   boolean True if successful False otherwise
*
*/
function plugin_install_thingstodo()
{
    global $pi_name, $pi_version, $gl_version, $pi_url, $NEWTABLE, $DEFVALUES, $NEWFEATURE;
    global $_TABLES, $_CONF;

    COM_errorLog("Attempting to install the $pi_name Plugin",1);

    // Create the Plugins Tables
    
    foreach ($NEWTABLE as $table => $sql) {
        COM_errorLog("Creating $table table",1);
        DB_query($sql,1);
        if (DB_error()) {
            COM_errorLog("Error Creating $table table",1);
            plugin_uninstall_thingstodo();
            return false;
            exit;
        }
        COM_errorLog("Success - Created $table table",1);
    }
    
    // Insert Default Data
    
    foreach ($DEFVALUES as $table => $sql) {
        COM_errorLog("Inserting default data into $table table",1);
        DB_query($sql,1);
        if (DB_error()) {
            COM_errorLog("Error inserting default data into $table table",1);
            plugin_uninstall_thingstodo();
            return false;
            exit;
        }
        COM_errorLog("Success - inserting data into $table table",1);
    }
    

    // Create the plugin admin security group

    foreach ($NEWFEATURE as $key => $value) {

        // Create the group
        COM_errorLog("Attempting to create Things to do {$value['group']} group", 1);
        DB_query("INSERT INTO {$_TABLES['groups']} (grp_name, grp_descr) " . "VALUES ('{$value['group']}', '{$value['description']}')", 1);
        if (DB_error()) {
            plugin_uninstall_thingstodo();
            return false;
            exit;
        }
        COM_errorLog('...success', 1);
        $group_id = DB_insertId();

        // Save the grp id for later uninstall
        COM_errorLog('About to save group_id to vars table for use during uninstall', 1);
        DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('{$value['feature']}', '{$group_id}')", 1);
        if (DB_error()) {
            plugin_uninstall_thingstodo();
            return false;
            exit;
        }
        COM_errorLog('...success', 1);

        // Create the feature
        COM_errorLog("Adding {$value['feature']} feature", 1);
        DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) VALUES ('{$value['feature']}','{$value['description']}')", 1);
        if (DB_error()) {
            COM_errorLog("Failure adding {$value['feature']} feature", 1);
            plugin_uninstall_thingstodo();
            return false;
            exit;
        }
        COM_errorLog('...success', 1);
        $feature_id = DB_insertId();

        // Give the group access to the feature
        COM_errorLog("Adding {$value['feature']} feature to {$value['group']} group",1);
        DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ('{$feature_id}', '{$group_id}')");
        if (DB_error()) {
            COM_errorLog("Failure adding {$value['feature']} feature to {$value['group']} group",1);
            plugin_uninstall_thingstodo();
            return false;
            exit;
        }
        COM_errorLog('...success', 1);

    }


    // Get the group numbers back from the "vars" table
    COM_errorLog("Attempting to get the group id numbers from the vars table", 1);
    $admin_id     = DB_GetItem($_TABLES['vars'], "value", "name='thingstodo.admin'");
    if (DB_error()) {
        plugin_uninstall_thingstodo();
        return false;
        exit;
    }
    COM_errorLog('...success', 1);
    $user_id     = DB_GetItem($_TABLES['vars'], "value", "name='thingstodo.user'");
    if (DB_error()) {
        plugin_uninstall_thingstodo();
        return false;
        exit;
    }
    COM_errorLog('...success', 1);


    // Make Root users members of the admin group. NOTE: Root group should always be 1
    COM_errorLog("Attempting to give all users in Root group ADMIN access to Things to do admin group",1);
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($admin_id, NULL, 1)");
    if (DB_error()) {
        plugin_uninstall_thingstodo();
        return false;
        exit;
    }
    COM_errorLog('...success', 1);

    // Make plugin admin group members of the user group
    COM_errorLog("Attempting to make all users in admin group members of the view group",1);
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($user_id, NULL, $admin_id)");
    if (DB_error()) {
        plugin_uninstall_thingstodo();
        return false;
        exit;
    }
    COM_errorLog('...success', 1);


    // Register the plugin with Geeklog
    COM_errorLog("Registering $pi_name plugin with Geeklog", 1);
    DB_delete($_TABLES['plugins'],'pi_name','thingstodo');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('$pi_name', '$pi_version', '$gl_version', '$pi_url', 1)");

    if (DB_error()) {
        plugin_uninstall_thingstodo();
        return false;
        exit;
    }

    COM_errorLog("Succesfully installed the $pi_name Plugin!",1);
    return true;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path_layout'] . 'thingstodo');
$T->set_file('install', 'install.thtml');
$T->set_var('install_header', $LANG_THINGS00['install_header']);
$T->set_var('img',$_CONF['site_url'] . '/thingstodo/images/thingstodo.gif');
$T->set_var('cgiurl', $_CONF['site_admin_url'] . '/plugins/thingstodo/install.php');
$T->set_var('admin_url', $_CONF['site_admin_url'] . '/plugins/thingstodo/index.php');

if ($action == 'install') {
    if (plugin_install_thingstodo()) {
        $T->set_var('installmsg1',$LANG_THINGS00['install_success']);
    } else {
        $T->set_var('installmsg1',$LANG_THINGS00['install_failed']);
    }
} else if ($action == "uninstall") {
   plugin_uninstall_thingstodo('installed');
   $T->set_var('installmsg1',$LANG_THINGS00['uninstall_msg']);
}

if (DB_count($_TABLES['plugins'], 'pi_name', 'thingstodo') == 0) {
    $T->set_var('installmsg2', $LANG_THINGS00['uninstalled']);
    $T->set_var('readme', $LANG_THINGS00['readme']);
    $T->set_var('installdoc', $LANG_THINGS00['installdoc']);
	$T->set_var('btnmsg', $LANG_THINGS00['install']);
	$T->set_var('action','install');
} else {
    $T->set_var('installmsg2', $LANG_THINGS00['installed']);
	$T->set_var('btnmsg', $LANG_THINGS00['uninstall']);
	$T->set_var('action','uninstall');
}
$T->parse('output','install');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;

?>