<?php

// +---------------------------------------------------------------------------+
// | Things to do Plugin 1.0 for Geeklog - The Ultimate Weblog                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the thingstodo |
// | PHP files.                                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Euan McKay                  -    euan@heatherengineering.com              |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+


/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/thingstodo/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/thingstodo/language/english.php');
}

/*
* Include thingstodo config file
*/
require_once ($_CONF['path'] . 'plugins/thingstodo/config.php');

// +---------------------------------------------------------------------------+
// | Things to do Plugin functions                                             |
// +---------------------------------------------------------------------------+

/*
* Show a message box
*/

function thingstodo_showMessage($message) {

    global $_CONF;

    $retval = '';

    if ($message != '') {
        $retval .= COM_startBlock( "Things to do plugin",
                           COM_getBlockTemplate( '_msg_block', 'header' ))
            . '<img src="' . $_CONF['layout_url']
            . '/thingstodo/images/thingstodo.gif" border="0" align="top" alt="">'
            . $message . '<br>'
            . COM_endBlock( COM_getBlockTemplate( '_msg_block', 'footer' ));
    }

    return $retval;
}


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* Universal Plugin:  Uncomment and fill in variables;
* 
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_thingstodo()
{
    global $_CONF;
    $menulabel = "Things to do";
    $menurul = $_CONF['site_url'] . "/thingstodo/index.php";
    $menuitems = array();
    if (SEC_hasRights('thingstodo.user')) {
        $menuitems["$menulabel"] = $menurul;
    }
    return $menuitems;
}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_thingstodo() 
{
    return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_thingstodo($showsitestats) 
{
    return '';
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_thingstodo() 
{
    global $_CONF;
    return array('Things to do',
                 $_CONF['site_admin_url'] . '/plugins/thingstodo/index.php',
                 $_CONF['layout_url'] . '/thingstodo/images/thingstodo.gif');
}

/**
* Returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_thingstodo() 
{
//    global $_CONF, $_TABLES;
//    if (SEC_hasRights('thingstodo.admin')) {
//        return array('Things to do', $_CONF['site_admin_url'] . '/plugins/thingstodo/index.php', DB_count($_TABLES['thingstodo']));
//    }
}

/**
* Returns the user option for this plugin
*
* Adds the plugin to the user menu
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/
function plugin_getuseroption_thingstodo() 
{
//    global $_CONF;
//    if (SEC_hasRights('thingstodo.user,thingstodo.admin','OR')) {
//        return array('Things to do', $_CONF['site_url'] . '/thingstodo/index.php', 0);
//    }
}


/**
* Display Things to do in the center block.
*
* @param   where   int      where the page will be displayed (0..3)
* @param   page    int      page number
* @param   topic   string   topic ID
* @return          string   HTML for the page (can be empty)
*/
function plugin_centerblock_thingstodo ($where = 1, $page = 0, $topic ='') {
    global $_CONF, $_USER, $_TABLES, $LANG_THINGS_PRIORITY, $TTD_TIME;
    $home = DB_getItem($_TABLES['thingstodo_vars'],'val',"ref='cb_home'");

    if ($topic == '') {
        if ($home == '0') {
            $show = false;
        } else {
            $show = true;
        }
    } else {
        $show = true;
    }

    $enabled = DB_getItem($_TABLES['thingstodo_vars'],'val',"ref='cb_options'");
    if (SEC_hasRights('thingstodo.user,thingstodo.admin', 'OR') && ($enabled >'0') && ($show == true)) {
        $item_limit  = "7";         // How many items you want displayed
        $title_limit = "40";        // The length of characters of the subject you want displayed
        $retval      = '';
        $pos = $enabled;
        $filter = "WHERE status='0' ". COM_getPermSQL('AND');
        if ($topic <> '') {
            $filter .= " AND tid='". $topic."'";
        }

        if ($where == $pos) {
            $result = DB_query("SELECT id,title,agent,end,priority FROM {$_TABLES['thingstodo']} {$filter} ORDER BY created DESC LIMIT ".$item_limit);
            $nrows  = DB_numrows($result);
            if ($nrows == 0) {      // no items so return nothing
                $retval = '';
            } else {                // build block
                $retval .= COM_startBlock("Things to do plugin");
                $TTD = new Template($_CONF['path_layout'].'thingstodo');
                $TTD->set_file(array ('table'=>'cb_table.thtml','row'=>'cb_row.thtml'));
                $TTD->set_var('lang_title',"Title");
                $TTD->set_var('lang_agent', "Agent");
                $TTD->set_var('lang_priority',"Priority");
                $TTD->set_var('lang_completion',"Completion");
    
                for ($i = 1; $i <= $nrows; $i++) {
                    $A = DB_fetchArray($result);
                    $fullsubject = $A['title'];
                    if(strlen ($A['title']) > $title_limit) {
                        $A['title'] = substr($A['title'], 0, $title_limit);
                        $A['title'] .= "..";
                    }
                    $TTD->set_var('site_url',$_CONF['site_url']);
                    $TTD->set_var('id',$A['id']);
                    $TTD->set_var('title',$A['title']);
                    $TTD->set_var('uid',$A['agent']);
                    $TTD->set_var('agent', DB_getItem($_TABLES['users'],"username","uid=".$A['agent']));
                    $TTD->set_var('priority',$LANG_THINGS_PRIORITY[$A['priority']]);
                    $TTD->set_var('completion',strftime($TTD_TIME['full'],$A['end']));
                    $TTD->set_var('ttd_priority', "ttd_".$A['priority']);
                    $TTD->parse ('cbrow', 'row', true);
                }
    
                $TTD->parse ('output', 'table');
                $retval .= $TTD->finish ($TTD->get_var('output'));
                $retval .= COM_endBlock();
            }
        }
    } else {
        $retval = '';
    }

    return $retval;
}

/**
* Display Things to do in a phpblock.
*
* @param   where   int      where the page will be displayed (0..3)
* @param   page    int      page number
* @param   topic   string   topic ID
* @return          string   HTML for the page (can be empty)
*/
function phpblock_Thingstodo() {
    global $_CONF, $_TABLES;

    if (SEC_hasRights('thingstodo.user,thingstodo.admin', 'OR')) {
        $item_limit  = "10";         // How many items you want displayed
        $title_limit = "15";        // The length of characters of the subject you want displayed
        $retval      = '';
        $where       = "WHERE status='0' ".COM_getPermSQL('AND');
    
        $result = DB_query("SELECT id,title,priority FROM {$_TABLES['thingstodo']} ".$where." ORDER BY end DESC LIMIT ".$item_limit);
        $nrows  = DB_numrows($result);
    
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray($result);
            if(strlen ($A['title']) > $title_limit) {
                $A['title'] = substr($A['title'], 0, $title_limit);
                $A['title'] .= "..";
            }
            $retval .= '<a href="'.$_CONF['site_url'].'/thingstodo/index.php?mode=viewitem&id='.$A['id'].'"';
            if ($A['priority'] == '1') {
                $retval .= ' style="color:red;font-weight:bold;" ';
            }
            $retval .= '>'.$A['title'].'</a><br>';
        }
    } else {
        $retval = '';
    }

    return $retval;
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_thingstodo($installCheck='')
{
    global $_TABLES, $LANG_THINGS00;

    // The thingstodos need to be changed to the name of your plugin
    //
    $pi_name='thingstodo';
    $FEATURES = array ( 'thingstodo.admin', 'thingstodo.user');
    $TABLES = array ('thingstodo','thingstodo_vars');
    
    // Check and see if plugin is still enabled - if so display warning and exit
/*    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
	    COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
		$display .= COM_startBlock($LANG_THINGS00['warning']);
		$display .= $LANG_THINGS00['enabled'];
		$display .= COM_endBlock();
		echo $display;
		return false;
		exit;
	}*/

    // Ok to proceed and delete plugin

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the thingstodo plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'thingstodo'",1);

    // Drop thingstodo tables
    foreach($TABLES as $table) {
        $t = $_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    // Remove Security for this plugin

    COM_errorLog("Removing Things to do Plugin Admin Group", 1);
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'thingstodo.admin'");
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'thingstodo.admin'");
    COM_errorLog("Removing root users from admin of Things to do Plugin");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);

    COM_errorLog("Removing Things to do Plugin User Group", 1);
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'thingstodo.user'");
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'thingstodo.user'");
    COM_errorLog("Removing logged-in users from use of Things to do Plugin");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);

    // Remove all the associated features -- access rights
    COM_errorLog("Removing Things to do Plugin features", 1);
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }

    COM_errorLog('...success',1);
    return true;
}

?>